//This file will contain the linked list that will store my internal
//represenation of the datafile, it will also hold the structure I use while
//parsing

#ifndef __LL_H__
#define __LL_H__

typedef struct _property
{
  short pl;   // 0
  short b;    // 0
  short em;   // 0
  short i;    // 0
  short s;    // 0
  short tt;   // 0
  short u;    // 0
  char color; // a
  short size; // -1
} property ;

typedef struct _field
{
  struct _field *next;
  struct _field *prev;
  char *text;
  property prop;
} field;

field *addfield(field **bottom, property prop, char *text);
field *poptop(field **bottom);
field *popbottom(field **bottom);
field *bottom(field **bottom);
field *top(field **bottom);
#endif

