#include <stdio.h>
#include "test.h"
#include "ll.h"
#include "ploptim.h"

#ifndef NULL
#define NULL (void *)0
#endif

void pl_optimization(field **display)
{
  field *temp;
  field *temp2;
  field *t;

  t = top(display);
  temp = bottom(display);

  if (temp->next != NULL)
    {
      temp = temp->next;
      while (temp->next != t && temp != t)
	{
	  if (temp->prop.b == 0 && temp->prop.em == 0 &&
	      temp->prop.i == 0 && temp->prop.tt == 0 &&
	      temp->prop.u == 0 && temp->prop.s == 0 && pldiff(temp, temp->prev) > 1)
	    {
	      temp2 = temp;
	      while (temp2->next != t)
		{
		  if ((temp2->prop.b == 1 || temp2->prop.em == 1 ||
		      temp2->prop.i == 1 || temp2->prop.tt == 1 ||
		      temp2->prop.u >= 1 || temp2->prop.s == 1)) 
		    {
		      if (plsame(temp2, temp->prev) > 1)
			{
			  while (temp != temp2)
			    {
			      temp->prop.pl = 1;
			      temp = temp->next;
			    }
			  break;
			}
		      else
			break;
		    }
		  temp2 = temp2->next;
		}
	    }
	  temp=temp->next;
	}        
    }

}

int pldiff(field *f1, field *f2)
{
  int num = 0;
  
  if (f1->prop.b != f2->prop.b) num++;
  if (f1->prop.i != f2->prop.i) num++;
  if (f1->prop.em != f2->prop.em) num++;
  if (f1->prop.tt != f2->prop.tt) num++;
  if (f1->prop.s != f2->prop.s) num++;
  if (f1->prop.u != f2->prop.u) num += f2->prop.u;
  
   return num;
}

int plsame(field *f1, field *f2)
{
  int num = 0;
  
  //  fprintf(stderr, "same called\n");
  //show_field(f1);
  //show_field(f2);

  if (f1->prop.b == f2->prop.b && f1->prop.b != 0) num++;
  if (f1->prop.i == f2->prop.i && f1->prop.i != 0) num++;
  if (f1->prop.em == f2->prop.em && f1->prop.em != 0) num++;
  if (f1->prop.tt == f2->prop.tt && f1->prop.tt != 0) num++;
  if (f1->prop.s == f2->prop.s && f1->prop.s != 0) num++;
  num += (f2->prop.u <= f1->prop.u) ? f2->prop.u : f1->prop.u;

  return num;
}
