#include <stdio.h>
#include <stdlib.h>
#include "ll.h"
#include "test.h"

void show_display(field **display)
{
  field *f = bottom(display);

  while (f != NULL)
    {
      show_field(f);
      f = f->next;
    }

  return;
}

void show_field(field *f)
{
  fprintf(stderr, "<%s:%s>\n", 
	 show_context(f->prop),
	 f->text);

  return;
}

char *show_context(property context)
{
  char *temp;

  temp = (char *)malloc(sizeof(char) * 10);

  sprintf(temp, "%c%c%c%c%c%c%d%c%c",
	  (context.pl) ? 'P' : '_',
	  (context.b) ? 'B' : '_',
	  (context.em) ? 'E' : '_',
	  (context.i) ? 'I' : '_',
	  (context.s) ? 'S' : '_',
	  (context.tt) ? 'T' : '_',
	  (context.u),
	  (context.size >= 0) ? '0' + (context.size) : '?',
	  (context.color == 'a') ? '?' : context.color);
  
  return temp;
}

void examine_stack(field **stack)
{
  field *top;

  fprintf(stderr, "%p", stack);
  fprintf(stderr, ":%p", (* stack));
  top = (* stack);
  if (top != NULL)
    {
      while(top->next != NULL)
	{
	  top = top->next;
	  fprintf(stderr, ":%p", top);
	}
      fprintf(stderr, ":%p", top->next);
    }
  fprintf(stderr, "\n");

  return;
}
