//This file will contain the linked list that will store my internal
//represenation of the datafile, it will also hold the structure I use while
//parsing

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "test.h"
#include "ll.h"

#ifndef NULL
#define NULL (void *)0
#endif

field *addfield(field **bottom, property prop, char *text) 
{

  field *top, *t;

  if (text == NULL)
    return NULL;

  top = (field *) malloc(sizeof(field));

  if ((* bottom) == NULL) 
    {
      (* bottom) = top;
      top->prev = NULL;
    } 
  else 
    {
      t = (* bottom);
      while (t->next != NULL)
	t = t->next;
      
      t->next = top;
      top->prev = t;
    }

  top->next = NULL;
  top->prop = prop;
  top->text = (char *)malloc(sizeof(char) * (strlen(text) + 1));
  strcpy (top->text, text);
  top->text[strlen(text)] = '\0';

  return top;
}

field *poptop(field **bottom)
{
  field *top, *t;

  top = (* bottom);

  if (top == NULL)
    return NULL;
  if (top->next == NULL)
    {
      (* bottom) = NULL;
      return top;
    }

  while (top->next->next != NULL)
    top = top->next;
  
  t = top->next;
  top->next = NULL;
  t->prev = NULL;
  return t;
}

field *popbottom(field **bottom)
{
  field *b;
  b = (* bottom);
  if (b != NULL)
    {
      (* bottom) = (* bottom)->next;
      if (b->next != NULL)
	{
	  b->next->prev = NULL;
	  b->next = NULL;
	}
    }
  
  return b;
}

field *bottom(field **bottom)
{
  return (* bottom);
}

field *top(field **bottom)
{
  field *top;
  if ((top = (* bottom)) != NULL)
    while (top->next != NULL)
      top = top->next;

  return top;
}
